VERSION 5.00
Begin VB.UserControl XpGroupBox 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   2115
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3360
   ClipBehavior    =   0  'None
   ControlContainer=   -1  'True
   KeyPreview      =   -1  'True
   ScaleHeight     =   2115
   ScaleWidth      =   3360
   ToolboxBitmap   =   "XPGroupBox.ctx":0000
   Begin VB.PictureBox ProgressPic 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      Height          =   315
      Left            =   495
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   315
   End
   Begin VB.Label lblPercentage 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "0 %"
      Height          =   195
      Left            =   15
      TabIndex        =   0
      Top             =   15
      Visible         =   0   'False
      Width           =   255
   End
End
Attribute VB_Name = "XpGroupBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*******************************************************************************************************
'********************************************
'*********************              XpGroupbox (Part of XpControls)
'**
'*
'* Author: Jottum
'* Date  : 07/20/2007 (mm/dd/yyyy)
'* Site  : http://www.uitdeschriften.com/files/VB6/
'*
'* Feel free to use/modify this code, but:
'* - Please do not spread this code in modified form.
'* - Do not rename this control and spread its source.
'* - Leave this text where it is.
'* - Give proper credit to the author.
'*
'**
'*********************
'********************************************
'*******************************************************************************************************

Option Explicit      'ALLWAYS use Option Explicit!

' Local variables
Private meBorderStyle As BorderStyless
Private meDisabledBehavior As DisabledSettings
Private meVisibleBehavior As VisibleSettings
Private mePercentage As Integer
Private meShowPercentage As Boolean
Private meLegacyProgressStyle As ProgressStyles
Private meUseParentFormhDC As Boolean
Private meVisible As Boolean
Private meBackStyle As BackStyleConstants
Private meDisabledStyle As DisabledStyles
Private meCheckBoxCaption As Boolean
Private meCaption As String
Private mepTransparent As Boolean
Private mehWnd As Long
Private meHasDC As Boolean
Private meTabStop As Long
Private m_Picture As Picture
Private bMnemonic As Boolean

'Bitblt
Private h1 As Long
Private h2 As Long

Event Click()
Event DblClick()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Private WithEvents MyParent As Form
Attribute MyParent.VB_VarHelpID = -1

Private Const GWL_EXSTYLE = (-20)
Private Const GWL_STYLE = (-16)
Private Const WS_EX_WINDOWEDGE = &H100
Private Const WS_EX_CLIENTEDGE = &H200
Private Const WS_EX_STATICEDGE = &H20000
Private Const WS_HSCROLL = &H100000
Private Const WS_VSCROLL = &H200000

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hDC As Long, lpRect As RECT) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Sub InitCommonControls Lib "COMCTL32.DLL" ()
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" ( _
    ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" ( _
   ByVal hLibModule As Long) As Long
Private Declare Function GetPixel Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal X As Long, _
    ByVal Y As Long _
    ) As Long

Private m_hMod As Long

' Code by vbAccelerator.com
Private Enum ESetWindowPosStyles
    SWP_SHOWWINDOW = &H40
    SWP_HIDEWINDOW = &H80
    SWP_FRAMECHANGED = &H20 ' The frame changed: send WM_NCCALCSIZE
    SWP_NOACTIVATE = &H10
    SWP_NOCOPYBITS = &H100
    SWP_NOMOVE = &H2
    SWP_NOOWNERZORDER = &H200 ' Don't do owner Z ordering
    SWP_NOREDRAW = &H8
    SWP_NOREPOSITION = SWP_NOOWNERZORDER
    SWP_NOSIZE = &H1
    SWP_NOZORDER = &H4
    SWP_DRAWFRAME = SWP_FRAMECHANGED
    HWND_NOTOPMOST = -2
End Enum


'Tab constants. Code by vbAccelerator.com
Private Enum ThemeTabParts
   TAB_TABITEM = 1
   TAB_TABITEMLEFTEDGE = 2
   TAB_TABITEMRIGHTEDGE = 3
   TAB_TABITEMBOTHEDGE = 4
   TAB_TOPTABITEM = 5
   TAB_TOPTABITEMLEFTEDGE = 6
   TAB_TOPTABITEMRIGHTEDGE = 7
   TAB_TOPTABITEMBOTEDGE = 8
   TAB_PANE = 9
   TAB_BODY = 10
End Enum

Private Enum ThemeTabItemStates
   TIS_NORMAL = 1
   TIS_HOT = 2
   TIS_SELECTED = 3
   TIS_DISABLED = 4
   TIS_FOCUSED = 5
End Enum

Private Enum ThemeTabItemLeftEdgeStates
   TILES_NORMAL = 1
   TILES_HOT = 2
   TILES_SELECTED = 3
   TILES_DISABLED = 4
   TILES_FOCUSED = 5
End Enum

Private Enum ThemeTabItemRightEdgeStates
   TIRES_NORMAL = 1
   TIRES_HOT = 2
   TIRES_SELECTED = 3
   TIRES_DISABLED = 4
   TIRES_FOCUSED = 5
End Enum

Private Enum ThemeTabItemBotEdgeStates
   TIBES_NORMAL = 1
   TIBES_HOT = 2
   TIBES_SELECTED = 3
   TIBES_DISABLED = 4
   TIBES_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemStates
   TTIS_NORMAL = 1
   TTIS_HOT = 2
   TTIS_SELECTED = 3
   TTIS_DISABLED = 4
   TTIS_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemLeftEdgeStates
   TTILES_NORMAL = 1
   TTILES_HOT = 2
   TTILES_SELECTED = 3
   TTILES_DISABLED = 4
   TTILES_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemRightEdgeStates
   TTIRES_NORMAL = 1
   TTIRES_HOT = 2
   TTIRES_SELECTED = 3
   TTIRES_DISABLED = 4
   TTIRES_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemBotEdgeStates
   TTIBES_NORMAL = 1
   TTIBES_HOT = 2
   TTIBES_SELECTED = 3
   TTIBES_DISABLED = 4
   TTIBES_FOCUSED = 5
End Enum

' DrawEdge:
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8

Private Const BDR_OUTER = &H3
Private Const BDR_INNER = &HC
Private Const BDR_RAISED = &H5
Private Const BDR_SUNKEN = &HA

Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)

Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8

Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

' --

Private Const RASTERCAPS As Long = 38
Private Const RC_PALETTE As Long = &H100
Private Const SIZEPALETTE As Long = 104
Private Const SRCCOPY = &HCC0020

Private Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal xDest As Long, ByVal yDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function GetSysColorBrush Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const SW_HIDE = 0
Private Const SW_SHOW = 5

Private Declare Function OpenThemeData Lib "uxtheme.dll" _
   (ByVal hWnd As Long, ByVal pszClassList As Long) As Long

Private Declare Function CloseThemeData Lib "uxtheme.dll" _
   (ByVal hTheme As Long) As Long

Private Declare Function GetThemeColor Lib "uxtheme.dll" ( _
                 ByVal hTheme As Long, _
                 ByVal iPartId As Long, _
                 ByVal iStateId As Long, _
                 ByVal iPropId As Long, _
                 ByRef pColor As OLE_COLOR) As Long
                 
Private Declare Function DrawThemeText Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, _
    ByVal iStateId As Long, ByVal pszText As Long, _
    ByVal iCharCount As Long, ByVal dwTextFlag As Long, _
    ByVal dwTextFlags2 As Long, pRect As RECT) As Long
    
Private Declare Function DrawThemeBackground Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pClipRect As RECT) As Long
    
Private Declare Function GetThemeRect Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, _
   ByVal iPartId As Long, _
   ByVal iStateId As Long, _
   ByVal iPropId As Long, _
   ByRef pRect As RECT) As Long
   
Private Declare Function GetThemeFont Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, _
   ByVal hDC As Long, _
   ByVal iPartId As Long, _
   ByVal iStateId As Long, _
   ByVal iPropId As Long, _
   tLogFont As FONTSLOG) As Long
    
Private Declare Function GetThemeInt Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, ByVal iPartId As Long, _
   ByVal iStateId As Long, ByVal iPropId As Long, _
   piVal As Long) As Long
    
Private Const medef_BackStyle = 0
Private Const DT_LEFT = &H0
Private Const DT_TOP = &H0
Private Const DT_CENTER = &H1
Private Const DT_RIGHT = &H2
Private Const DT_VCENTER = &H4
Private Const DT_BOTTOM = &H8&
Private Const DT_SINGLELINE = &H20
Private Const BP_PUSHBUTTON = 1
Private Const BP_RADIOBUTTON = 2
Private Const BP_CHECKBOX = 3
Private Const BP_GROUPBOX = 4
Private Const BP_USERBUTTON = 5

Private Const PBS_NORMAL = 1
Private Const PBS_HOT = 2
Private Const PBS_PRESSED = 3
Private Const PBS_DISABLED = 4
Private Const PBS_DEFAULTED = 5
Private Const TMT_FONT = 210

Private Const EP_EDITTEXT = 1
Private Const ETS_NORMAL = 1
Private Const ETS_DISABLED = 4

'Private Const PP_BAR = 1
Private Const PP_NORMAL = 1

Private Const TMT_BORDERCOLORHINT = 3822    ' hint about border color used (for custom controls)
Private Const TMT_BORDERCOLOR = 3801

Private Const TMT_PROGRESSSPACESIZE = 2412
Private Const TMT_PROGRESSCHUNKSIZE = 2411
'

'Code: author unknown to me
Public Property Get ControlsContained() As Collection
   Dim kContainedControls As Collection
   Dim c As Control
   Set kContainedControls = New Collection
   For Each c In ContainedControls
      kContainedControls.Add c
   Next
   Set ControlsContained = kContainedControls
End Property

Public Property Get BackStyle() As BackStyleConstants
Attribute BackStyle.VB_Description = "Transparent will show what's behind the control, Opaque has the default vbButtonFace/vbWindowBackground  color."
   BackStyle = meBackStyle
End Property

Public Property Let BackStyle(ByVal Setting As BackStyleConstants)
   meBackStyle = Setting
   Redraw
   PropertyChanged "BackStyle"
End Property

Public Property Get TabStop() As Boolean
   TabStop = meTabStop
End Property

Public Property Let TabStop(ByVal Setting As Boolean)
   meTabStop = Setting
   PropertyChanged "TabStop"
End Property

Public Property Get Percentage() As Integer
Attribute Percentage.VB_Description = "Enter a value between 0 and 100 to show progress when BorderStyle is set to XpProgress."
   Percentage = mePercentage
End Property

Public Property Let Percentage(ByVal Setting As Integer)
   If Setting < 0 Then Setting = 0
   If Setting > 100 Then Setting = 100
   mePercentage = Setting
   Redraw
   PropertyChanged "Percentage"
End Property

Public Property Get ShowPercentage() As Boolean
   ShowPercentage = meShowPercentage
End Property

Public Property Let ShowPercentage(ByVal Setting As Boolean)
   meShowPercentage = Setting
   Redraw
   PropertyChanged "ShowPercentage"
End Property

Public Property Get LegacyProgressStyle() As ProgressStyles
   LegacyProgressStyle = meLegacyProgressStyle
End Property

Public Property Let LegacyProgressStyle(ByVal Setting As ProgressStyles)
   meLegacyProgressStyle = Setting
   Redraw
   PropertyChanged "LegacyProgressStyle"
End Property

Public Property Get Visible() As Boolean
Attribute Visible.VB_Description = "Hide or show XpGroupBox."
   Visible = meVisible
End Property

Public Property Let Visible(ByVal Setting As Boolean)
   Dim c As Control
   
   Visible = Setting
   meVisible = Setting
   
   If meVisibleBehavior = IncludeAll Then
      On Error Resume Next 'Trap errors just in case.
      For Each c In ContainedControls
         c.Visible = Setting
      Next
      On Error GoTo 0 'Reset normal error trapping.
   End If
   
   UserControl.Refresh
   PropertyChanged "Visible"
End Property

Public Property Get UseParentFormhDC() As Boolean
Attribute UseParentFormhDC.VB_Description = "Use Parent as a source for the transparency regardless whether the control is contained by another control. This can be useful when working with a vbTabStrip for example when you're using DrawTabStripCheat."
   UseParentFormhDC = meUseParentFormhDC
End Property

Public Property Let UseParentFormhDC(ByVal Setting As Boolean)
   meUseParentFormhDC = Setting
   Redraw
   PropertyChanged "UseParentFormhDC"
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Although displayed, the default theme or Windows 3D colors are used."
   BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal Setting As OLE_COLOR)
   UserControl.BackColor() = Setting
   PropertyChanged "BackColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
   ForeColor = UserControl.ForeColor
End Property

Private Property Let ForeColor(ByVal Setting As OLE_COLOR)
   UserControl.ForeColor() = Setting
   PropertyChanged "ForeColor"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Enable or disable XpGroupBox."
   Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal Setting As Boolean)
   Dim c As Control
   
   UserControl.Enabled() = Setting
   
   If meDisabledBehavior = IncludeControls Then
      On Error Resume Next 'If c doesn't have enabled property
      For Each c In ContainedControls
         c.Enabled = Setting
      Next
      On Error GoTo 0 'Reset normal error trapping.
   End If
   
   Redraw
   PropertyChanged "Enabled"
End Property

Public Property Get Font() As Font
   Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal Setting As Font)
   Set UserControl.Font = Setting
   Redraw
   PropertyChanged "Font"
End Property

Public Property Get BorderStyle() As BorderStyless
Attribute BorderStyle.VB_Description = "Returns or sets a value determining the visual aspects of XpGroupBox. Note: When None, a dotted rect is displayed in the IDE, not at runtime."
   BorderStyle = meBorderStyle
End Property

Public Property Let BorderStyle(ByVal Setting As BorderStyless)
   meBorderStyle = Setting
   Redraw
   PropertyChanged "BorderStyle"
End Property

Public Sub Refresh()
Attribute Refresh.VB_Description = "Repaint and refresh XpGroupBox."
   DoEvents
   SizePaint
End Sub

Private Sub UserControl_Click()
   RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
   RaiseEvent DblClick
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
   RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Set the Caption for XpGroupBox"
   Caption = meCaption
End Property

Public Property Let Caption(ByVal Setting As String)
   If InStrB(Setting, "&") <> 0 Then
      bMnemonic = True
   Else
      bMnemonic = False
   End If
   meCaption = Setting
   Redraw
   PropertyChanged "Caption"
End Property

Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_MemberFlags = "400"
   FontUnderline = UserControl.FontUnderline
End Property

Public Property Let FontUnderline(ByVal Setting As Boolean)
   UserControl.FontUnderline = Setting
   Redraw
   PropertyChanged "FontUnderline"
End Property

Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_MemberFlags = "400"
   FontStrikethru = UserControl.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal Setting As Boolean)
   UserControl.FontStrikethru = Setting
   Redraw
   PropertyChanged "FontStrikethru"
End Property

Public Property Get FontSize() As Single
Attribute FontSize.VB_MemberFlags = "400"
   FontSize = UserControl.FontSize
End Property

Public Property Let FontSize(ByVal Setting As Single)
On Error Resume Next
   UserControl.FontSize = Setting
   Redraw
   PropertyChanged "FontSize"
On Error GoTo 0
End Property

Public Property Get FontName() As String
Attribute FontName.VB_MemberFlags = "400"
   FontName = UserControl.FontName
End Property

Public Property Let FontName(ByVal Setting As String)
   UserControl.FontName = Setting
   Redraw
   PropertyChanged "FontName"
End Property

Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_MemberFlags = "400"
   FontItalic = UserControl.FontItalic
End Property

Public Property Let FontItalic(ByVal Setting As Boolean)
   UserControl.FontItalic = Setting
   Redraw
   PropertyChanged "FontItalic"
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_MemberFlags = "400"
   FontBold = UserControl.FontBold
End Property

Public Property Let FontBold(ByVal Setting As Boolean)
   UserControl.FontBold = Setting
   Redraw
   PropertyChanged "FontBold"
End Property

Public Property Get hWnd() As Long
   hWnd = UserControl.hWnd
End Property

Public Property Get hDC() As Long
   hDC = UserControl.hDC
End Property

Public Property Get HasDC() As Boolean
   HasDC = UserControl.HasDC
End Property

Public Property Let HasDC(ByVal Setting As Boolean)
   meHasDC = Setting
   PropertyChanged "HasDC"
End Property

Public Property Get MouseIcon() As Picture
   Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal Setting As Picture)
   Set UserControl.MouseIcon = Setting
   PropertyChanged "MouseIcon"
End Property

Public Property Get MousePointer() As MousePointerConstants
   MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal Setting As MousePointerConstants)
   UserControl.MousePointer = Setting
   PropertyChanged "MousePointer"
End Property

Public Property Get DisabledBehavior() As DisabledSettings
Attribute DisabledBehavior.VB_Description = "Sets whether contained controls' Enabled property inherit containers setting."
   DisabledBehavior = meDisabledBehavior
End Property

Public Property Let DisabledBehavior(ByVal Setting As DisabledSettings)
   meDisabledBehavior = Setting
   PropertyChanged "DisabledBehavior"
End Property

Public Property Get VisibleBehavior() As VisibleSettings
Attribute VisibleBehavior.VB_Description = "Sets whether contained controls' visible property inherit containers setting."
   VisibleBehavior = meVisibleBehavior
End Property

Public Property Let VisibleBehavior(ByVal Setting As VisibleSettings)
   meVisibleBehavior = Setting
   Visible = Visible 'Fire property let
   PropertyChanged "VisibleBehavior"
End Property

Private Sub UserControl_Paint()
   SizePaint
End Sub

Private Sub UserControl_Resize()
   SizePaint
End Sub

Private Sub UserControl_Show()
   SizePaint
End Sub

Private Sub UserControl_Terminate()
   Set MyParent = Nothing
   FreeLibrary m_hMod
End Sub

Private Sub UserControl_Initialize()
   m_hMod = LoadLibrary("shell32.dll") 'Prevents app crash on exit (XP)
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()

   Set UserControl.Font = Ambient.Font
   
   Caption = Ambient.DisplayName
   
   meBorderStyle = Xp
      
   meBackStyle = Transparent
   
   meDisabledBehavior = IncludeControls
   
   meVisibleBehavior = IncludeAll
   
   meLegacyProgressStyle = [Horizontal Chunk]
   
   meTabStop = False
   
   'ThemeSysFont = ThemeSysFont
      
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   Dim lR As Long

   If Ambient.UserMode Then
      Set MyParent = UserControl.Parent
   End If

   BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
   ForeColor = PropBag.ReadProperty("ForeColor", vbButtonText)
   meUseParentFormhDC = PropBag.ReadProperty("UseParentFormhDC", False)
   meDisabledBehavior = PropBag.ReadProperty("DisabledBehavior", ContainerOnly)
   mePercentage = PropBag.ReadProperty("Percentage", 0)
   meShowPercentage = PropBag.ReadProperty("ShowPercentage", True)
   meLegacyProgressStyle = PropBag.ReadProperty("LegacyProgressStyle", [Horizontal Chunk])
   meVisibleBehavior = PropBag.ReadProperty("VisibleBehavior", IncludeAll)
   meHasDC = PropBag.ReadProperty("HasDc", True)
   meTabStop = PropBag.ReadProperty("TabStop", False)
   Enabled = PropBag.ReadProperty("Enabled", True)
   meVisible = PropBag.ReadProperty("Visible", True)
   meBorderStyle = PropBag.ReadProperty("BorderStyle", Xp)
   meCaption = PropBag.ReadProperty("Caption", Ambient.DisplayName)
   meCheckBoxCaption = PropBag.ReadProperty("CheckBoxCaption", False)
   Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
   FontUnderline = PropBag.ReadProperty("FontUnderline", False)
   FontTransparent = PropBag.ReadProperty("FontTransparent", True)
   FontStrikethru = PropBag.ReadProperty("FontStrikethru", False)
   FontSize = PropBag.ReadProperty("FontSize", 8)
   FontName = PropBag.ReadProperty("FontName", "MS Sans Serif")
   FontItalic = PropBag.ReadProperty("FontItalic", False)
   FontBold = PropBag.ReadProperty("FontBold", False)
   Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
   MousePointer = PropBag.ReadProperty("MousePointer", vbDefault)
   meBackStyle = PropBag.ReadProperty("BackStyle", medef_BackStyle)
   Set m_Picture = PropBag.ReadProperty("Picture", Nothing)

   mehWnd = UserControl.hWnd                             'One call, global visible.

   On Error Resume Next
      Set UserControl.Font.Name = ThemeSysFont
      UserControl.FontName = ThemeSysFont
   On Error GoTo 0
      
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

   Call PropBag.WriteProperty("UseParentFormhDC", meUseParentFormhDC, False)
   Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
   Call PropBag.WriteProperty("HasDC", meHasDC, True)
   Call PropBag.WriteProperty("TabStop", meTabStop, False)
   Call PropBag.WriteProperty("ShowPercentage", meShowPercentage, True)
   Call PropBag.WriteProperty("Percentage", mePercentage, 0)
   Call PropBag.WriteProperty("LegacyProgressStyle", meLegacyProgressStyle, [Horizontal Chunk])
   Call PropBag.WriteProperty("BackColor", UserControl.BackColor, vbButtonFace)
   Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, vbButtonText)
   Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
   Call PropBag.WriteProperty("Visible", meVisible, True)
   Call PropBag.WriteProperty("DisabledBehavior", meDisabledBehavior, ContainerOnly)
   Call PropBag.WriteProperty("VisibleBehavior", meVisibleBehavior, IncludeAll)
   Call PropBag.WriteProperty("BorderStyle", meBorderStyle, Xp)
   Call PropBag.WriteProperty("BackStyle", meBackStyle, Transparent)
   Call PropBag.WriteProperty("Caption", meCaption, Ambient.DisplayName)
   Call PropBag.WriteProperty("CheckBoxCaption", meCheckBoxCaption, False)
   Call PropBag.WriteProperty("FontUnderline", UserControl.FontUnderline, False)
   Call PropBag.WriteProperty("FontTransparent", UserControl.FontTransparent, True)
   Call PropBag.WriteProperty("FontStrikethru", UserControl.FontStrikethru, False)
   Call PropBag.WriteProperty("FontSize", UserControl.FontSize, 8)
   Call PropBag.WriteProperty("FontName", UserControl.FontName, "MS Sans Serif")
   Call PropBag.WriteProperty("FontItalic", UserControl.FontItalic, False)
   Call PropBag.WriteProperty("FontBold", UserControl.FontBold, False)
   Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
   Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, vbDefault)
   Call PropBag.WriteProperty("Picture", m_Picture, Nothing)

End Sub

Private Sub Redraw()

   Dim lHdc As Long
   Dim i As Long
   Dim hTheme As Long
   Dim tTextR As RECT
   Dim tR2 As RECT
   Dim tRex As RECT
   Dim tR As RECT
   Dim lR As Long
   Dim lStyle As Long
   Dim bVisible As Boolean
   Dim tLogFont As FONTSLOG
   Dim bIsThemed As Boolean
   Dim lEnabled As Boolean
   Dim strLength As Long
   Dim tmpCaption As String
   Dim hBrush As Long
   Dim pColor As OLE_COLOR
   Dim lpPoint As POINTAPI
   Dim lState As Long
   Dim intpercent As Integer
   Dim strShowPercentage As String
      
   lHdc = UserControl.hDC
   bIsThemed = IsThemed(mehWnd)
   lEnabled = UserControl.Enabled
   
   If meBorderStyle <> ProgressXp Then
      lblPercentage.Visible = False
   End If
   
   If meBorderStyle = None Then
      
      UserControl.Cls                     'Wipe it clean.
      
      If meBackStyle = Transparent Then
      
         MakeContainerTransparent
         
      End If
      
      If Not Ambient.UserMode Then
      
         DrawDottedRect     'Only visible while in the IDE, otherwhise you
         Exit Sub           'wont know where the container is, or if you do,
                            'it will make placing other controls a lot easier.
      End If
      
   Else
   
      'Clear entire control
      hBrush = GetSysColorBrush(vbButtonFace And &H1F&)
      GetClientRect Me.hWnd, tR
      FillRect lHdc, tR, hBrush
      DeleteObject hBrush
      
      If meBackStyle = Transparent Then
      
         MakeContainerTransparent
         
      End If
   
   End If

   strLength = (UserControl.TextWidth(meCaption) / Screen.TwipsPerPixelX) + 6
   
   If bMnemonic Then
      strLength = strLength - (UserControl.TextWidth("&") / Screen.TwipsPerPixelX)
   End If

   If bIsThemed Then
            
      ProgressPic.Visible = False
            
      Select Case meBorderStyle
      
         Case Xp
                     
            hTheme = OpenThemeData(mehWnd, StrPtr(ClassListItems.PSZ_BUTTON))
                     
            tR.Top = ScaleY(UserControl.TextHeight("T"), vbTwips, vbPixels) / 2
            tR.Left = 0
            tR.Right = ScaleX(UserControl.ScaleWidth, vbTwips, vbPixels)
            tR.Bottom = ScaleY(UserControl.ScaleHeight, vbTwips, vbPixels)
            
            lR = DrawThemeBackground(hTheme, lHdc, _
                                     BP_GROUPBOX, _
                                     PBS_NORMAL, _
                                     tR, tR)
                                             
            If LenB(meCaption) > 0 Then
            
               'Calculate caption position
               
               tTextR.Top = 0
               tTextR.Left = IIf(bMnemonic, ScaleX(UserControl.TextWidth("&"), vbTwips, vbPixels) + 2, 9)
               tTextR.Right = strLength + 8
               tTextR.Bottom = ScaleY(UserControl.TextHeight("T"), vbTwips, vbPixels)
            
               'First wipe the border part where the Caption gets printed
               'by copying a small part of the background to that position,
               'or clear the area if not Transparent. Since we're only shifting
               '2 pixels up, you don't notic this at all.
               
               If meBackStyle = Transparent Then
               
                  lR = BitBlt(lHdc, tTextR.Left - 1, tR.Top, strLength, tR.Top + 2, _
                              lHdc, tTextR.Left - 1, tR.Top + 2, vbSrcCopy)
               
               Else
               
                  tRex.Left = tTextR.Left - 1
                  tRex.Top = tR.Top - 1
                  tRex.Right = tTextR.Right + 1
                  tRex.Bottom = tR.Top + 1
                  
                  hBrush = GetSysColorBrush(vbButtonFace And &H1F&)
                  FillRect lHdc, tRex, hBrush
                  DeleteObject hBrush
               
               End If
            
               'tTextR.left = tTextR.left + 2
               
               If Me.Enabled Then                  'Doesn't seem to have much effect...
               
                  lState = PBS_NORMAL
                  
               Else
               
                  lState = PBS_DISABLED
               
               End If
            
               lR = DrawThemeText(hTheme, _
                                  lHdc, _
                                  BP_GROUPBOX, _
                                  lState, _
                                  StrPtr(meCaption), _
                                  -1, _
                                  DT_CENTER Or DT_TOP, _
                                  0, _
                                  tTextR)
                                       
            End If
      
            CloseThemeData hTheme
            
         Case Legacy
                                 
            tR.Top = ScaleY(UserControl.TextHeight("T"), vbTwips, vbPixels) / 2
            tR.Left = 0
            tR.Right = ScaleX(UserControl.ScaleWidth, vbTwips, vbPixels)
            tR.Bottom = ScaleY(UserControl.ScaleHeight, vbTwips, vbPixels)
            
            hBrush = GetSysColorBrush(vbButtonFace And &H1F&)
            
            If meBackStyle = Opaque Then
            
               LSet tR2 = tR
               tR2.Top = 0
               FillRect lHdc, tR2, hBrush
               
            End If
            
            lR = DrawEdge(lHdc, _
                          tR, _
                          EDGE_ETCHED, _
                          BF_RECT)  'Legacy frame border
            
            If LenB(meCaption) > 0 Then
            
               'Calculate caption position
               
               tTextR.Top = 0
               tTextR.Left = 5
               tTextR.Right = strLength + 5
               tTextR.Bottom = ScaleY(UserControl.TextHeight("T"), vbTwips, vbPixels)
            
               'First wipe the border part where the Caption gets printed
               'by copying a small part of the background to that position,
               'or clear the area if not Transparent.
               
               If meBackStyle = Transparent Then
               
                  lR = BitBlt(lHdc, tTextR.Left + 2, tR.Top, strLength - 2, tR.Top, _
                              lHdc, tTextR.Left + 2, tR.Top + 2, vbSrcCopy)
               
               Else
               
                  tRex.Left = tTextR.Left + 2
                  tRex.Top = tR.Top - 1
                  tRex.Right = tTextR.Right
                  tRex.Bottom = tR.Top + 2
                  
                  FillRect lHdc, tRex, hBrush
               
               End If
                  
               tTextR.Left = tTextR.Left - 2
               tTextR.Right = tTextR.Right - 2
                  
               lR = DrawText(lHdc, _
                             meCaption, _
                             Len(meCaption), _
                             tTextR, _
                             vbButtonText)
               
            End If
                  
            DeleteObject hBrush
                  
         Case TextBoxXp
                     
            tR.Top = 0
            tR.Left = 0
            tR.Right = ScaleX(UserControl.ScaleWidth, vbTwips, vbPixels)
            tR.Bottom = ScaleY(UserControl.ScaleHeight, vbTwips, vbPixels)
            
            hTheme = OpenThemeData(mehWnd, StrPtr("Edit"))
                     
            If hTheme <> 0 Then
            
               If meBackStyle = Transparent Then
            
                  If GetThemeColor(hTheme, EP_EDITTEXT, ETS_NORMAL, TMT_BORDERCOLOR, pColor) = S_OK And meBackStyle = Transparent Then
                     
                     UserControl.ForeColor = pColor
                     
                  Else
                  
                     UserControl.ForeColor = vbButtonShadow 'Next best thing
                  
                  End If
                  
                  MakeContainerTransparent
                  
                  tR.Top = 0
                  tR.Left = 0
                  tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels)
                  tR.Bottom = ScaleY(UserControl.Height, vbTwips, vbPixels)
                                                   
                  MoveToEx UserControl.hDC, tR.Right, tR.Top, lpPoint
                  LineTo UserControl.hDC, tR.Left, tR.Top
                  
                  MoveToEx UserControl.hDC, tR.Right, tR.Bottom - 1, lpPoint
                  LineTo UserControl.hDC, tR.Left, tR.Bottom - 1
                  
                  MoveToEx UserControl.hDC, tR.Left, tR.Top, lpPoint
                  LineTo UserControl.hDC, tR.Top, tR.Bottom
                  
                  MoveToEx UserControl.hDC, tR.Right - 1, tR.Top, lpPoint
                  LineTo UserControl.hDC, tR.Right - 1, tR.Bottom
                                    
               ElseIf lEnabled And meBackStyle = Opaque Then
               
                  lR = DrawThemeBackground(hTheme, _
                                           lHdc, _
                                           EP_EDITTEXT, _
                                           ETS_NORMAL, _
                                           tR, tR)
                                    
               ElseIf Not lEnabled And meBackStyle = Opaque Then
               
                  lR = DrawThemeBackground(hTheme, _
                                           lHdc, _
                                           EP_EDITTEXT, _
                                           ETS_DISABLED, _
                                           tR, tR)
               
               End If
                              
               CloseThemeData hTheme
               
               UserControl.ForeColor = vbButtonText
               
            End If
            
         Case ProgressXp
                     
            tR.Top = 0
            tR.Left = 0
            tR.Right = ScaleX(UserControl.ScaleWidth, vbTwips, vbPixels)
            tR.Bottom = ScaleY(UserControl.ScaleHeight, vbTwips, vbPixels)
   
            hTheme = OpenThemeData(mehWnd, StrPtr("Progress"))
                     
            If hTheme <> 0 Then
               
               lR = DrawThemeBackground(hTheme, _
                                        lHdc, _
                                        PP_BAR, _
                                        PP_NORMAL, _
                                        tR, tR)
            
               If mePercentage > 0 Then
               
                  If Not IsVista Then
                     InflateRect tR, -3, -3 'Xp has bigger margings...
                  Else
                     InflateRect tR, -1, -1
                  End If
                                    
                  If UserControl.ScaleWidth > UserControl.ScaleHeight Then
                  
                     LSet tRex = tR
                     
                     If Not IsVista Then
                        tRex.Right = tRex.Right + 1
                     End If
                     
                     tRex.Right = (tRex.Right / 100) * mePercentage
                  
                     lR = DrawThemeBackground(hTheme, _
                                              lHdc, _
                                              PP_CHUNK, _
                                              PP_BAR, _
                                              tRex, tRex)
                                                 
                     If meShowPercentage Then
                     
                        strShowPercentage = Str$(mePercentage) & " %"
                        lblPercentage.Caption = strShowPercentage
                     
                        tTextR.Left = (UserControl.Width / 2) - UserControl.TextWidth(strShowPercentage) / 2
                        tTextR.Top = (UserControl.ScaleHeight / 2) - (UserControl.TextHeight("T") / 2) + 1

                        lblPercentage.Visible = True
                        lblPercentage.Move tTextR.Left, tTextR.Top
                                             
                     Else
                     
                        lblPercentage.Visible = False
                     
                     End If
                                          
                  Else
                  
                     If meShowPercentage Then
                     
                        strShowPercentage = Str$(mePercentage) & " %"
                        lblPercentage.Caption = strShowPercentage
                     
                        tTextR.Left = (UserControl.Width / 2) - UserControl.TextWidth(strShowPercentage) / 2
                        tTextR.Top = (UserControl.ScaleHeight / 2) - (UserControl.TextHeight("T") / 2) + 1
   
                        lblPercentage.Visible = True
                        lblPercentage.Move tTextR.Left, tTextR.Top
                     
                     Else
                     
                        lblPercentage.Visible = False
                     
                     End If
                  
                     tR.Top = tR.Bottom - ScaleY(UserControl.ScaleHeight / 100, vbTwips, vbPixels) * mePercentage
                  
                     lR = DrawThemeBackground(hTheme, _
                                              lHdc, _
                                              PP_CHUNKVERT, _
                                              PP_BARVERT, _
                                              tR, tR)
                  
                  End If
                  
               Else
               
                  If meShowPercentage Then
                  
                     strShowPercentage = "0 %"
                  
                     lblPercentage.Caption = strShowPercentage
                  
                     tTextR.Left = (UserControl.Width / 2) - UserControl.TextWidth(strShowPercentage) / 2
                     tTextR.Top = (UserControl.ScaleHeight / 2) - (UserControl.TextHeight("T") / 2) + 1

                     lblPercentage.Visible = True
                     lblPercentage.Move tTextR.Left, tTextR.Top
                  
                  Else
                  
                     lblPercentage.Visible = False
                  
                  End If
               
               End If
                                                
               CloseThemeData hTheme
            
            End If
            
         Case TabPage
         
            GetClientRect UserControl.hWnd, tR                       'Get the drawing area rectangle
               
            If Not meCaption = vbNullString Then                     'Some calculating...
            
               tR.Top = 0                                            'Top margin
               tR.Left = 0                                           'Left margin
               tR.Right = (UserControl.Width / Screen.TwipsPerPixelX)    'Right margin
               tR.Bottom = (UserControl.Height / Screen.TwipsPerPixelY)  'Button margin below the Tab.
            
               tR2.Top = 1        'Tab text.
               tR2.Left = 0
               tR2.Bottom = 300 / Screen.TwipsPerPixelY
               tR2.Right = (UserControl.TextWidth(meCaption) / Screen.TwipsPerPixelX) + 16
               
               tR.Top = tR.Top + (tR2.Bottom - tR2.Top) 'Make some space for header.
               
               strLength = (UserControl.TextWidth(meCaption) / Screen.TwipsPerPixelX)
                                                            'Get length of meCaption.
            End If
               
            hTheme = OpenThemeData(UserControl.hWnd, StrPtr("Tab")) 'Open with correct theme item
                                                              
            If meCaption = vbNullString Then              '...but not to fake a tab.
            
               tR.Left = tR.Left + 1                     'left borders on a visible part
                                                         'of UserControl.
            End If
      
            lR = DrawThemeBackground(hTheme, UserControl.hDC, _
                                     TAB_PANE, _
                                     TIS_NORMAL, _
                                     tR, tR)             'Draw the Tab Pane (No gradient
                                                         'background)
               
            InflateRect tR, -3, -3                    'Adjust the rectangle size, to
                                                      'Draw the Tab body (Gradient)
                                                      'inside the Tab Pane.
            lR = DrawThemeBackground(hTheme, UserControl.hDC, _
                                     TAB_BODY, _
                                     TIS_NORMAL, _
                                     tR, tR)          'Draw Tab body (Gradient)
                                
      
            InflateRect tR2, 0, 1
      
            If Not meCaption = vbNullString Then
            
               lR = DrawThemeBackground(hTheme, UserControl.hDC, _
                                        TAB_TOPTABITEM, _
                                        TIBES_SELECTED, _
                                        tR2, tR2)             'Draw Tab Header
                                                 
               lR = DrawThemeBackground(hTheme, UserControl.hDC, _
                                        TAB_TOPTABITEMRIGHTEDGE, _
                                        TTIRES_SELECTED, _
                                        tR2, tR2)             'Draw Tab Header Right Edge
                                        
               lR = DrawThemeBackground(hTheme, UserControl.hDC, _
                                        TAB_TOPTABITEMLEFTEDGE, _
                                        TILES_SELECTED, _
                                        tR2, tR2)             'Draw Tab Header Left Edge
                                                 
               tR2.Top = tR2.Top + 3                          'A little smuggling ...
                                                                          
               lR = DrawThemeText(hTheme, _
                                  UserControl.hDC, _
                                  TAB_TOPTABITEM, _
                                  TTIBES_SELECTED, _
                                  StrPtr(meCaption), _
                                  -1, _
                                  DT_CENTER Or DT_VCENTER, _
                                  0, _
                                  tR2)                        'Draw the text.
      
            
            End If
                                                            
            CloseThemeData hTheme                              'Release Handle
         
      End Select
      
   Else 'Not themed, draw legacy controls
      
      If meBorderStyle = None Then
         hBrush = GetSysColorBrush(vbButtonFace And &H1F&)
         
         tR.Top = 0
         tR.Left = 0
         tR.Right = ScaleX(UserControl.ScaleWidth, vbTwips, vbPixels)
         tR.Bottom = ScaleY(UserControl.ScaleHeight, vbTwips, vbPixels)
         
         FillRect lHdc, tR2, hBrush
         DeleteObject hBrush
         
         If meBackStyle = Transparent Then
            MakeContainerTransparent
         End If
         
         Exit Sub
      End If
         
      
      If meBorderStyle = Legacy Or meBorderStyle = Xp Then
         
         hBrush = GetSysColorBrush(vbButtonFace And &H1F&)
         
         tR.Top = ScaleY(UserControl.TextHeight("T"), vbTwips, vbPixels) / 2
         tR.Left = 0
         tR.Right = ScaleX(UserControl.ScaleWidth, vbTwips, vbPixels)
         tR.Bottom = ScaleY(UserControl.ScaleHeight, vbTwips, vbPixels)
         
         If meBackStyle = Opaque Then
         
            LSet tR2 = tR
            tR2.Top = 0
            FillRect lHdc, tR2, hBrush
            
         End If
         
         lR = DrawEdge(lHdc, _
                       tR, _
                       EDGE_ETCHED, _
                       BF_RECT)  'Legacy frame border
         
         'Calculate caption position
      
         If LenB(meCaption) > 0 Then
      
            'Calculate caption position
            
            tTextR.Top = 0
            tTextR.Left = 5
            tTextR.Right = strLength + 5
            tTextR.Bottom = ScaleY(UserControl.TextHeight("T"), vbTwips, vbPixels)
         
            'First wipe the border part where the Caption gets printed
            'by copying a small part of the background to that position,
            'or clear the area if not Transparent.
            
            If meBackStyle = Transparent Then
            
               lR = BitBlt(lHdc, tTextR.Left + 2, tR.Top, strLength - 2, tR.Top, _
                           lHdc, tTextR.Left + 2, tR.Top + 2, vbSrcCopy)
            
            Else
            
               tRex.Left = tTextR.Left + 2
               tRex.Top = tR.Top - 1
               tRex.Right = tTextR.Right
               tRex.Bottom = tR.Top + 2
               
               FillRect lHdc, tRex, hBrush
            
            End If
               
            tTextR.Left = tTextR.Left - 2
            tTextR.Right = tTextR.Right - 2
               
            lR = DrawText(lHdc, _
                          meCaption, _
                          Len(meCaption), _
                          tTextR, _
                          vbButtonText)
            
            DeleteObject hBrush
            
         End If
                                 
      ElseIf meBorderStyle = TabPage Then
           
         GetClientRect UserControl.hWnd, tR                       'Get the drawing area rectangle
            
         If Not meCaption = vbNullString Then                     'Some calculating...
         
            tR.Top = 0                                            'Top margin
            tR.Left = 0                                           'Left margin
            tR.Right = (UserControl.Width / Screen.TwipsPerPixelX) - 3   'Right margin
            tR.Bottom = (UserControl.Height / Screen.TwipsPerPixelY)  'Button margin below the Tab.
         
            tR2.Top = 1        'Tab text.
            tR2.Left = 0
            tR2.Bottom = 300 / Screen.TwipsPerPixelY
            tR2.Right = (UserControl.TextWidth(meCaption) / Screen.TwipsPerPixelX) + 16
            
            tR.Top = tR.Top + (tR2.Bottom - tR2.Top) - 1 'Make some space for header.
            
            strLength = (UserControl.TextWidth(meCaption) / Screen.TwipsPerPixelX)
                                                         'Get length of meCaption.
         End If
           
         DrawEdge UserControl.hDC, tR, EDGE_RAISED, BF_RECT
         
         If Not meCaption = vbNullString Then
         
            DrawEdge UserControl.hDC, tR2, EDGE_RAISED, BF_RIGHT
            
            DrawEdge UserControl.hDC, tR2, EDGE_RAISED, BF_LEFT
                                                   
            InflateRect tR2, -1, 1                          'A little adjustment.
                                          
            DrawEdge UserControl.hDC, tR2, EDGE_RAISED, BF_TOP
            
            InflateRect tR2, 1, -1                          'Reset.
            
            'Since whe're only drawing the borders, the legacy fake Tab is fully
            'Transparent. With the below function, I'm smuggling  a little again
            'by copying a small part just below the frame top edge and draw it
            'over the frame top edge where the caption will be drawn.
            
            lR = BitBlt(UserControl.hDC, tR2.Left + 2, tR2.Bottom - 1, strLength + 12, tR2.Left + 3, _
                        UserControl.hDC, tR2.Left + 2, tR2.Bottom + 1, vbSrcCopy)
                     
            tR2.Right = tR2.Right - 8
            tR2.Top = tR2.Top + 3
            
            DrawText UserControl.hDC, meCaption, Len(meCaption), tR2, vbButtonText
            
         End If
      
      ElseIf meBorderStyle = TextBoxXp Or ProgressXp Then
      
         tR.Top = 0
         tR.Left = 0
         tR.Right = (UserControl.Width / Screen.TwipsPerPixelX)
         tR.Bottom = (UserControl.Height / Screen.TwipsPerPixelY)
      
         If meBorderStyle = ProgressXp Then
         
            If meBackStyle = Opaque Then
               hBrush = GetSysColorBrush(vbWindowBackground And &H1F&)
               FillRect lHdc, tR, hBrush
               DeleteObject hBrush
            End If
         
            ProgressPic.Visible = True
            ProgBar CLng(mePercentage), vbButtonFace, vbHighlight, vbBlack, meShowPercentage
            
            DrawEdge UserControl.hDC, tR, EDGE_SUNKEN, BF_RECT 'DrawEdge UserControl.hdc, tR, BDR_SUNKENOUTER, BF_RECT
            
         Else
         
            If meBackStyle = Opaque Then
               hBrush = GetSysColorBrush(vbWindowBackground And &H1F&)
               FillRect lHdc, tR, hBrush
               DeleteObject hBrush
            End If
         
            DrawEdge UserControl.hDC, tR, EDGE_SUNKEN, BF_RECT
            
         End If
                  
      End If
   
   End If
      
End Sub

   '*************************************************************************
   '* This function is written by GumbyTheCat and used with his permission. *
   '*************************************************************************

Private Sub MakeContainerTransparent()

   '*************************************************************************
   '* displays what's behind the container control, thereby effectively     *
   '* rendering the container Transparent.                                  *
   '*************************************************************************

   On Error Resume Next

   Dim r As Long
   Dim ctl              As Control
   Dim rc               As RECT
   Dim h1               As Long, h2 As Long
   
   h2 = UserControl.hDC               ' the dc of this control.
   
   If Not meUseParentFormhDC Then     ' Added by Jottum
   
      If UserControl.Parent.hWnd = UserControl.ContainerHwnd Then
         'the container resides on a Form, so use parent hDC.
         UserControl.Parent.AutoRedraw = True ' added by mru
         h1 = UserControl.Parent.hDC
      Else
         'the container resides in another container, so use parent container's hDC.
         For Each ctl In UserControl.Parent.Controls
         'find container.
            If ctl.hWnd = UserControl.ContainerHwnd Then 'Found our container
               ctl.AutoRedraw = True 'AutoRedraw must be True
               h1 = ctl.hDC 'Get the containers hDC
               Exit For
            End If
         Next
      End If
   
   '  get offsets for BitBlt.
      If UserControl.Extender.Container.ScaleMode = vbTwips Then
         rc.Left = UserControl.Extender.Left \ Screen.TwipsPerPixelX
         rc.Top = UserControl.Extender.Top \ Screen.TwipsPerPixelY
         rc.Right = (UserControl.ScaleWidth \ Screen.TwipsPerPixelX)
         rc.Bottom = (UserControl.ScaleHeight \ Screen.TwipsPerPixelY)
      Else
         rc.Left = UserControl.Extender.Left
         rc.Top = UserControl.Extender.Top
         rc.Right = UserControl.ScaleWidth
         rc.Bottom = UserControl.ScaleHeight
      End If
   
   Else
   
      UserControl.Extender.Parent.AutoRedraw = True ' Added by Jottum
      h1 = UserControl.Extender.Parent.hDC
      
      pGetClientRect rc
      
   End If
   
'  Copy background to our usercontrol hDC.
   r = BitBlt(h2, 0, 0, rc.Right, rc.Bottom, h1, rc.Left, rc.Top, vbSrcCopy)

End Sub

Private Sub DrawDottedRect()

   If Not Ambient.UserMode Or InIDE = -1 Then    ' Running in the IDE.
   
      Dim tR As RECT
      
      tR.Top = 0
      tR.Left = 0
      tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels)
      tR.Bottom = ScaleY(UserControl.Height, vbTwips, vbPixels)
      
      DrawFocusRect UserControl.hDC, tR ' To show the control (in the IDE only) when
                                        ' BorderStyle is set to None.

   End If

End Sub

Private Sub MyParent_Resize()

   Redraw

End Sub

Private Sub MyParent_Paint()

   Redraw

End Sub

'Return -1 if we're running in the IDE or 0 if were running compiled.
'Code by vbAccelerator.com

Private Property Get InIDE() As Long

   Static Value As Long
  
   If Value = 0 Then
   
      Value = 1
      Debug.Assert True Or InIDE()                  'This line won't exist in the
      InIDE = Value - 1                             'compiled app.
      
   End If
  
   Value = 0
   
End Property

'Code by vbAccelerator.com
Private Sub pGetClientRect(rc As RECT)
Dim tP As POINTAPI
    ' Get window rect of the user control:
    GetWindowRect UserControl.hWnd, rc
    tP.X = rc.Left
    tP.Y = rc.Top
    ' Adjust to coordinates of user control's container:
    ScreenToClient UserControl.Parent.hWnd, tP
    rc.Right = rc.Right + (tP.X - rc.Left)
    rc.Bottom = rc.Bottom + (tP.Y - rc.Top)
    rc.Left = tP.X
    rc.Top = tP.Y
End Sub

'Code by Kim Pederson
Private Function ProgBar(PercentIn As Long, _
    Optional BGcolor As Long = vbWhite, _
    Optional FGcolor As Long = vbBlue, _
    Optional TextColor = vbBlack, _
    Optional DisplayText As Boolean = True) As Boolean
    
    Dim OnePercent As Single
    Dim PBarWidth As Long
    Dim PBarHeight As Long
    Dim T As Long
    Dim i As Long
    Dim Temp As Long
    Dim tR As RECT
    Dim lR As Long
    Static j As Long
    
    On Error GoTo Err_Handler
    
    If (j = PercentIn) Then
      Exit Function
    End If
    If j > PercentIn Then
       'ProgressPic.Cls
    End If
            
      With ProgressPic
          .ScaleMode = vbTwips
          .AutoRedraw = True
          .Left = ScaleX(1, vbPixels, vbTwips)
          .Top = ScaleY(1, vbPixels, vbTwips)
          .Width = UserControl.Width - ScaleX(2, vbPixels, vbTwips)
          .Height = UserControl.Height - ScaleY(2, vbPixels, vbTwips)
          .BackColor = BGcolor
          .ForeColor = FGcolor
          .Refresh
          .ScaleMode = vbPixels
          .ZOrder
      End With
    
    ' Get the width and height of the bar...
    PBarWidth = ProgressPic.ScaleWidth
    PBarHeight = ProgressPic.ScaleHeight
    OnePercent = PBarWidth / 100
    
    Select Case meLegacyProgressStyle
    
       Case [Vertical Solid] ' Vertical Progress bar
           
           OnePercent = PBarHeight / 100
           
           For T = PBarHeight - (OnePercent * PercentIn) To PBarHeight
               ProgressPic.Line (1, T - 1)-(PBarWidth - 1, T - 1)
               DoEvents
           Next T
           
           If DisplayText = True Then
               ' Print percent done on bar (for vert style)
               ProgressPic.CurrentX = PBarWidth / 2 - 16
               ProgressPic.CurrentY = PBarHeight / 2 - 6
               ProgressPic.ForeColor = TextColor
               ProgressPic.Print "" & PercentIn & "%"
           
               ' Percent done on bar turnes the
               ' background color as the bar passes
               For T = PBarHeight - (OnePercent * PercentIn) To PBarHeight
                   For i = 0 To PBarWidth
                       If GetPixel(ProgressPic.hDC, i, T) = TextColor _
                           Then ProgressPic.PSet (i, T), BGcolor
                       DoEvents
                   Next i
                   If T > OnePercent * 60 Then T = PBarHeight
                   DoEvents
               Next T
           End If
           
       Case [Horizontal Chunk] ' Chunks (Win95/98 look) - should use without %done text over it.
           ' Draw the Progress
           For T = 0 To OnePercent * (PercentIn)
               ProgressPic.Line (T + 1, 1)-(T + 1, PBarHeight - 1)
               'DoEvents
           Next T
           
           ' Make some chunks...
           For T = 0 To OnePercent * (PercentIn) Step (OnePercent * 6)
               ProgressPic.ForeColor = BGcolor
   '            draw an inner box of background color...
               ProgressPic.Line (0, 0)-(PBarWidth - 1, 0)
               ProgressPic.Line (0, 0)-(0, PBarHeight - 1)
               ProgressPic.Line (PBarWidth - 1, 0)-(PBarWidth - 1, PBarHeight - 1)
               ProgressPic.Line (0, PBarHeight - 1)-(PBarWidth - 1, PBarHeight - 1)
   '
   '            Draw the latest vertical line
               ProgressPic.Line (T - 2, 0)-(T - 2, PBarHeight)
               ProgressPic.Line (T - 1, 0)-(T - 1, PBarHeight)
               ProgressPic.ForeColor = FGcolor
               'DoEvents
           Next T
           
       Case Else
           ' Draw the Progress
           For T = 0 To OnePercent * (PercentIn - 1)
               ProgressPic.Line (T + 1, 1)-(T + 1, PBarHeight - 1)
               'DoEvents
           Next T
           
    End Select
    
    If DisplayText = True Then
        
        If meLegacyProgressStyle <> [Horizontal Chunk] Then
            ' Print percent done on bar...
            ProgressPic.CurrentX = PBarWidth / 2 - 7
            ProgressPic.CurrentY = PBarHeight / 2 - 8
            ProgressPic.ForeColor = TextColor
            ProgressPic.Print "" & PercentIn & "%"
        
            ' Percent done on bar turnes the background color as the bar passes
            If PercentIn > 40 Then
                For T = OnePercent * 40 To OnePercent * (PercentIn)
                    For i = 0 To PBarHeight
                        If GetPixel(ProgressPic.hDC, T, i) = TextColor Then
                            ProgressPic.PSet (T, i), ProgressPic.BackColor
                        End If
                    Next i
                    'DoEvents
                    If T > OnePercent * 60 Then T = _
                        OnePercent * (PercentIn)
                Next T
            End If
        End If
        
    End If
    
    tR.Top = 0
    tR.Left = 0
    tR.Right = (UserControl.Width / Screen.TwipsPerPixelX)
    tR.Bottom = (UserControl.Height / Screen.TwipsPerPixelY)
    
    If PercentIn = 0 Then
       ProgressPic.Cls
    End If
    
    DrawEdge UserControl.hDC, tR, BDR_SUNKENOUTER, BF_RECT
    
    ' Remember what percent we're at...
    j = PercentIn
    
    ' Tell us if it all went well
    
    ProgBar = True: Exit Function
    
Err_Handler:
    
    ' Tell us if it didn't
    ProgBar = False
    
End Function

Private Sub SizePaint()
   
   With ProgressPic
       .ScaleMode = vbTwips
       .AutoRedraw = True
       .Left = ScaleX(1, vbPixels, vbTwips)
       .Top = ScaleY(1, vbPixels, vbTwips)
       .Width = UserControl.Width - ScaleX(2, vbPixels, vbTwips)
       .Height = UserControl.Height - ScaleY(2, vbPixels, vbTwips)
       .Refresh
       .ScaleMode = vbPixels
       .ZOrder
   End With
   
   Redraw
   
End Sub

